import { AudioDevice } from '../utils/audiodevice';
import { Credentials } from '../utils/config';
export declare class SSHService {
    private ssh;
    credentials: Credentials;
    constructor();
    connect: () => Promise<any>;
    newConnection: (credentials: Credentials, password: string, onConnected: () => void, onSSHCopyId: () => void, onCredentialsSaved: () => void) => Promise<void>;
    private connectInternal;
    disconnect: () => Promise<void>;
    isAssistantInstalled: () => Promise<boolean>;
    getOSVersion: () => Promise<string>;
    installSnipsPlatformDemo: (listener: (output: string) => void) => Promise<string>;
    speakerTest: () => Promise<string>;
    static fetchBootHostname: (ips: string[]) => Promise<{
        ip: string;
        hostname: string;
        snipsHostname: string;
    }[]>;
    getCaptureLevel: (card?: number | undefined) => Promise<string>;
    setCaptureLevel: (card?: number | undefined, level?: number | undefined) => Promise<string>;
    getVolumeLevel: (card?: number | undefined) => Promise<string>;
    setVolumeLevel: (card?: number | undefined, level?: number | undefined) => Promise<string>;
    recordAudio: (name: string) => Promise<string>;
    stopRecording: () => Promise<string>;
    listCaptureDevices: () => Promise<AudioDevice[]>;
    listOuputDevices: () => Promise<AudioDevice[]>;
    launchSnipsWatch: (listener: (string: any) => void) => Promise<string>;
    journalctlLogs: (listener: (string: any) => void) => Promise<string>;
    snipsServicesSystemctlStatus: () => Promise<{
        name: string;
        active: boolean;
    }[]>;
    playAudio: (name: string) => Promise<string>;
    removeAudioFile: (name: string) => Promise<string>;
    setupAsoundConf: (outputDevice: AudioDevice, captureDevice: AudioDevice) => Promise<string>;
    copySnipsFile: (snipsfile: string) => Promise<any>;
    runSnipsmanagerInstall: (listener: (string: any) => void) => Promise<string>;
    runSnipsManager: (listener: (string: any) => void) => Promise<string>;
    installSnips: (listener: (string: any) => void) => Promise<string>;
    packagesVersion: () => Promise<string>;
    updateWifi: (name: string, passphrase: string) => Promise<string>;
    statusWifi: () => Promise<string>;
    reconnectWifi: () => Promise<string>;
    disconnectWifi: () => Promise<string>;
    private sshCommandLog;
    sshCopyId: (hostname: string, username: string) => Promise<string>;
    private ssh_keygen_binPath();
    private sshKeygen;
    private add_snips_rsa_key_to_ssh_config_if_needed();
}
